poj 1195 单点更新 区间求和

Mobile phones

Time Limit: 5000 MS Memory Limit: 65536 KB

64-bit integer IO format: %I64d , %I64u Java class name: Main

[Submit] [Status] [Discuss]

Description

Suppose that the fourth generation mobile phone base stations in the Tampere area operate as follows. The area is divided into squares. The squares form an S * S matrix with the rows and columns numbered from 0 to S-1. Each square contains a base station. The number of active mobile phones inside a square can change because a phone is moved from a square to another or a phone is switched on or off. At times, each base station reports the change in the number of active phones to the main base station along with the row and the column of the matrix.

Write a program, which receives these reports and answers queries
about the current total number of active mobile phones in any
rectangle-shaped area.

Input

The input is read from standard input as integers
and the answers to the queries are written to standard output as
integers. The input is encoded as follows. Each input comes on a
separate line, and consists of one instruction integer and a number of
parameter integers according to the following table.

The values will always be in range, so there is no need to check
them. In particular, if A is negative, it can be assumed that it will
not reduce the square value below zero. The indexing starts at 0, e.g.
for a table of size 4 * 4, we have 0 <= X <= 3 and 0 <= Y <=
3.

Table size: 1 * 1 <= S * S <= 1024 * 1024

Cell value V at any time: 0 <= V <= 32767

Update amount: -32768 <= A <= 32767

No of instructions in input: 3 <= U <= 60002

Maximum number of phones in the whole table: M= 2^30

Output

Your program should not answer anything to lines
with an instruction other than 2. If the instruction is 2, then your
program is expected to answer the query by writing the answer as a
single line containing a single integer to standard output.

Sample Input

0 4
1 1 2 3
2 0 0 2 2
1 1 1 2
1 1 2 -1
2 1 1 2 3
3

Sample Output

3
4
 #include <iostream>
 #include <string.h>
 #include <stdio.h>

 using namespace std;
 #define max 1025
 int c[max][max];
 int n;

 int lowbit(int x)
 {
     return x&-x;
 }

 void update(int x,int y,int val)
 {
     for(int i=x;i<=n;i+=lowbit(i))
     {
         for(int j=y;j<=n;j+=lowbit(j))
         {
             c[i][j]+=val;
         }
     }
 }

int get_sum(int x,int y)
 {
     int s=0;
     for(int i=x;i>0;i-=lowbit(i))
     {
         for(int j=y;j>0;j-=lowbit(j))
         {
             s+=c[i][j];
         }
     }
     return s;
 }

 int main()
    {
        int i,j,s,T,x,y,x1,y1,val;
        while(1)
        {
            scanf("%d",&T);
            if (T==3) break;
            if (T==0)
            {
                scanf("%d",&n);
                memset(c,0,sizeof(c));
            }
            if (T==1)
            {
                scanf("%d%d%d",&x,&y,&val);
                update(x+1,y+1,val);   ///脚标从0开始  所以要+1喽~~~~
            }
            if (T==2)
            {
                scanf("%d%d%d%d",&x,&y,&x1,&y1);  ///同理
                printf("%d\n",get_sum(x1+1,y1+1)+get_sum(x,y)-get_sum(x1+1,y)-get_sum(x,y1+1));
            }
        }
        return 0;
    }

poj 1195 单点更新 区间求和

时间: 2024-07-30 15:28:22

poj 1195 单点更新 区间求和的相关文章

hdu 1166 敌兵布阵(线段树之 单点更新+区间求和)

敌兵布阵                                                                             Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Problem Description C国的死对头A国这段时间正在进行军事演习,所以C国间谍头子Derek和他手下Tidy又开始忙乎了.A国在海岸线沿直线布置了N个工兵

LightOJ 1112 Curious Robin Hood (单点更新+区间求和)

http://lightoj.com/volume_showproblem.php?problem=1112 题目大意: 1 i        将第i个数值输出,并将第i个值清0 2 i v     将第i个数值加v 3 i j      输出从i到j的数值和 简单的单点更新+区间求和,代码很简单的模板 但此题有一个神坑的地方当操作为1是输出第i个数值不是直接输出,而是通过查找输出(太坑了...) #include<stdio.h> #include<string.h> #incl

HYSBZ 1036 树链剖分(单点更新区间求和求最大值)

http://www.lydsy.com/JudgeOnline/problem.php?id=1036 Description 一棵树上有n个节点,编号分别为1到n,每个节点都有一个权值w.我们将以下面的形式来要求你对这棵树完成一些操作: I. CHANGE u t : 把结点u的权值改为t II. QMAX u v: 询问从点u到点v的路径上的节点的最大权值 III. QSUM u v: 询问从点u到点v的路径上的节点的权值和 注意:从点u到点v的路径上的节点包括u和v本身 Input 输入

树状数组 模板 单点更新 区间求和

(来自luogu)原题目 lowbit(x)=2^k次幂,k为x末尾0的数量.大家可以模拟试试lowbit (-x)=(~x)+1,把x取反+1 void update(int x,int k)表示a[x]+=k(单点更新) int sum(int x)表示求1-x区间和 求x-y区间和只需要sum(y)-sum(x-1)即可 #include <iostream> #include <string> #include <cstring> #define lowbit(

poj 2828 Buy Tickets 【线段树】【逆序插入 + 单点更新 + 区间求和】

Buy Tickets Time Limit: 4000MS   Memory Limit: 65536K Total Submissions: 16067   Accepted: 8017 Description Railway tickets were difficult to buy around the Lunar New Year in China, so we must get up early and join a long queue- The Lunar New Year wa

hdu1394(枚举/树状数组/线段树单点更新&amp;区间求和)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=1394 题意:给出一个循环数组,求其逆序对最少为多少: 思路:对于逆序对: 交换两个相邻数,逆序数 +1 或 -1, 交换两个不相邻数 a, b, 逆序数 += 两者间大于 a 的个数 - 两者间小于 a 的个数: 所以只要求出初始时的逆序对数,就可以推出其余情况时的逆序对数.对于求初始逆序对数,这里 n 只有 5e3,可以直接暴力 / 树状数组 / 线段树 / 归并排序: 代码: 1.直接暴力 1

POJ 3468 A Simple Problem with Integers(线段树模板之区间增减更新 区间求和查询)

A Simple Problem with Integers Time Limit: 5000MS   Memory Limit: 131072K Total Submissions: 140120   Accepted: 43425 Case Time Limit: 2000MS Description You have N integers, A1, A2, ... , AN. You need to deal with two kinds of operations. One type o

HDU 4893 线段树的 点更新 区间求和

Wow! Such Sequence! Time Limit: 10000/5000 MS (Java/Others)    Memory Limit: 65536/65536 K (Java/Others)Total Submission(s): 2067    Accepted Submission(s): 619 Problem Description Recently, Doge got a funny birthday present from his new friend, Prot

【HDU】1754 I hate it ——线段树 单点更新 区间最值

I Hate It Time Limit: 9000/3000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)Total Submission(s): 37448    Accepted Submission(s): 14816 Problem Description 很多学校流行一种比较的习惯.老师们很喜欢询问,从某某到某某当中,分数最高的是多少.这让很多学生很反感. 不管你喜不喜欢,现在需要你做的是,就是按照老师的要